import {
  select,
  csv,
  scaleLinear,
  scaleTime,
  extent,
  axisLeft,
  axisBottom,
  line,
  max
} from 'd3';

//redering svg tag from html
const svg = select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');

//Creating Line graph
const render = data => { 
  //Declaring constants we are using
  const title = 'Test';
  
  const xValue = d =>{d.date}; //display dates on x axis
  const xAxisLabel = 'Date';

  const yValue = d => d.nb_musique; //display salees value on y axis
  const yAxisLabel = 'Nombre de Musique';
  
  const margin = { top: 60, right: 40, bottom: 88, left: 150 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  //container
  
  
  //center g in svg
  const g = svg.append('g')
    .attr('transform', `translate(${margin.left},${margin.top})`);
  
  
  // Create X scale with year values
  const xScale = scaleTime()
  //complete set of values
    .domain(extent(data, xValue))
  //returns the minimum and maximum value in an array from the given array using natural order.
    .range([0, innerWidth]) //output bounds
    .nice(); //round values out
  
  //console.log(xScale.data);
 
  //creating xAxis  
  const xAxis = axisBottom(xScale)
    .tickSize(-innerHeight)
    .tickPadding(15);
  
  
  // Create Y scale with sales values
  const yScale = scaleLinear()
    .domain([0, max(data, yValue )])
    .range([innerHeight, 0])
    .nice();
  
  //creating yAxis  
  const yAxis = axisLeft(yScale)
    .tickSize(-innerWidth)
    .tickPadding(10);
  
  //Appending Y axis label to svg
  const yAxisG = g.append('g').call(yAxis);
  	yAxisG.selectAll('.domain').remove();
  	yAxisG.append('text')
      .attr('class', 'axis-label')
      .attr('y', -90)
      .attr('x', -innerHeight / 3)
      .attr('fill', 'black')
      .attr('transform', `rotate(-90)`)
      .text(yAxisLabel);
  
  //Appending X axis label to svg
  const xAxisG = g.append('g').call(xAxis)
    	.attr('transform', `translate(0,${innerHeight})`);
  
  xAxisG.select('.domain').remove();
  
  xAxisG.append('text')
      .attr('class', 'axis-label')
      .attr('y', 70)
      .attr('x', innerWidth / 2)
      .attr('fill', 'black')
      .text(xAxisLabel);
  
  //Creating line graphs between x and y axis
  const lineGenerator = d3.line()
  	.x(d => xScale(xValue(d)))
  	.y(d => yScale(yValue(d))); //coordinates in pixels
  
  //Appending line graph to svg
  g.append('path')
  	.attr('class', 'line_path')
  	.attr('d', lineGenerator(data))
  //Appending title of graph to svg
  g.append('text')
      .attr('class', 'title')
      .attr('y', -10)
      .text(title);
};



let newData = new Array();
//let listeGenre = new Array();
//let listeGenreDate = new Array();
//Récupérer toutes les données
d3.json("album.json").then((data) => { 

      let indexGenre;
      // Pour chaque élément des données
      data.forEach(function(d){
        console.log("0");
        if(!d.genre ==""){
  			if(!d.dateRelease ==""){
          console.log("1");
          //Traitement dates
          const date = new Date(d.dateRelease);
          const year = date.getFullYear();
          console.log("newData : " + newData);
          if(newData.length == 0){
              console.log("3");
               newData.push({
                        "genre" : d.genre,
                        "date": date,
                        "nb_musique": 1
               });
          } else {
          	newData.forEach(function(d){
            console.log("2");
            indexGenre = newData.indexOf(d.genre);
              //Si genre non présent dans newData
              if(indexGenre === -1){
                console.log("5");
                newData.push({
                        "genre" : d.genre,
                        "date": date,
                        "nb_musique": 1
                });
              }//Si genre présent dans listeGenre
                else{
                  console.log("6");
                  if (newData[indexGenre].date == date){
                    console.log("7");
                    newData[indexGenre].nb_musique = newData[indexGenre].nb_musique+1;
                  } else {
                    console.log("8");
                    newData.push({
                        "genre" : d.genre,
                        "date": date,
                        "nb_musique": 1
                    });
                  }
                }
              });
              }
            	console.log(newData);

        	}
        }
        console.log(newData);
    });
});
        
          
          
        
          /*let listeDatePossible = new Array();
          //Pour chaque élement des nouvelles données
          newData.forEach(function(dd){

            //Traitement dates
            const date = new Date(d.dateRelease);
            const year = date.getFullYear();

            indexGenre = listeGenre.indexOf(d.genre);
            //Si genre non présent dans listeGenre
            if(indexGenre === -1){
              console.log("here if");
              listeGenre.push({ "genre" : d.genre });
              newData.push({
                "genre" : d.genre,
                "dates" : [{
                  "date": date,
                  "nb_musique": 1
                }]
              });
              listeDatePossible.push({ "date" : date });
              listeGenreDate.push({ "genre":d.genre, "date" : date });

              //Si genre présent dans listeGenre
            } else {

              let indexDate;
              newData[indexGenre].dates.forEach(function(ddd){

                  indexDate = listeDatePossible.indexOf(dd.date);
                  //Si date non présent dans listeDate
                  if(indexDate === -1){
                    newData[indexGenre].push({
                      "dates" : [{
                        "date": date,
                        "nb_musique": 1
                      }]
                    });
                    listeDatePossible.push({ "date" : date });
                    listeGenreDate.push({ "genre": d.genre, "date" : date });

                  //Si date présent dans listeDate
                  } else {
                    newData[indexGenre].dates[indexDate].nb_musique = newData[indexGenre].dates[indexDate].nb_musique+1;

                  }//dernier else
              });//For Each sur newData[indexGenre].dates
            } // grand else
          }); //For Each sur newData
        		//Trier les dates par ordre croissant 
  					newData.sort(function (a, b) {
            	return d3['ascending'](
              	+a.date,
              	+b.date
            	);
    				})//Sort newData
              }//If date
  }//If genre
      });// For Each sur data

  console.log(newData);
  
  render(newData);
  
});*///Lecture des données

  
 //------------------------------------------------- 
  
  
  
  
  
  /*let i = 0;
  //Trier les données
  data.forEach(function(d){    
    let isPresent = false;
  	let j = 0;
    let index;
    let k = 0;
    let indexDate;
    let isPresentDate = false;
    newData.forEach(function(dd){      
      if(newData[j].genre == data[i].genre){
        isPresent = true;
        index = j;
        
        /*newData[j].dates.forEach(function(ddd){  
          const date1 = new Date(data[i].dateRelease);
          console.log(newData[j].dates[k].date);
          console.log(date1);
          if(newData[j].dates[k].date == date1){
            isPresentDate = true;
            indexDate = k; 
          }else{
            //Push sur liste de dates
            newData[j].dates.push({
              	"dates": [{
                   "date": date1,
            		 	 "nb_musique" : 1
                  }] 
            });
                  
          }
          k++;
        });*/
     /* }
    j++;
    });
    
    if(isPresentDate){
      newData[index].dates[indexDate].nb_musique = newData[index].dates[indexDate].nb_musique+1;
    }
    else{
      
      if(!data[i].genre ==""){
        if(!data[i].dateRelease ==""){
          const date = new Date(data[i].dateRelease);
          newData.push({
                 "genre": data[i].genre,
            		 "dates": [{
                   "date": date,
            		 	 "nb_musique" : 1
                  }]       
          });
        }
      }
    }
    isPresent = false;
    i++;*/
    
    
    
    
  //});
    
